//==============================================================
// Cette fonction extrait les liens du fichier fourni et lance le traitement
function ChargeFichier(url) 
    {
    // =====================================================================================================================================
    // =========================================== CREATION DE LA REQUETE POUR INTERROGER LE FICHIER DE LIENS ==============================
    // =====================================================================================================================================

    var FileRequest = false ;
    // Le if else qui suit crée l'instance FileRequest  de XMLHtttRequest au mieux des possibilités du navigateur
    if (window.XMLHttpRequest) 
		{ // Mozilla, Safari,...
   		FileRequest = new XMLHttpRequest();
		try
			{
			netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');
			}
		catch(e)
			{
			}
		}
    else 
		if (window.ActiveXObject) 
			{ // IE
			try 
				{
				FileRequest = new ActiveXObject("Msxml2.XMLHTTP") ;
				}
			catch (e)
				{
				try 
					{
					FileRequest = new ActiveXObject("Microsoft.XMLHTTP");
					}
				catch (e) {}
				}
			}
    // Si cela n'a pas marché, on stoppe tout
    if (!FileRequest) 
        {
       	alert('Abandon :( Impossible de créer une instance XMLHTTP');
      	return false;
        }
    // =====================================================================================================================================
    // =========================================== EXTRACTION DES LIENS DU FICHIER =========================================================
    // =====================================================================================================================================

    // Si la création de la requete a réussi, alors on s'en sert pour ouvrir le fichier à tester, donné en paramètre url à la fonction
    try
        {
        FileRequest.open('GET', url , false);
        document.getElementById('compteur').innerHTML = "<p>HyperTeste ouvre le fichier... Veuillez patienter...</p>\n" ;
        FileRequest.send(null);
        document.getElementById('compteur').innerHTML = "<p>HyperTeste lit le fichier... Veuillez patienter...</p>\n" ;
			
        var fichier= FileRequest.responseText ; // on récupère sous forme de texte le contenu du fichier
	
        // ======================================================================================================
        // Creation des expressions rationnelles pour extraction des url 
        // ======================================================================================================
        // Les versions 06.02 et suivantes extraient aussi https, lorsque http est requis, par l'ajout de [sS]? aux expressions rationnelles
        if (document.getElementById('typedurl0').checked)       // si les liens ftp et http sont voulus
                {
                // la regexp qui suit cherche les url mais exclut les url en début de ligne (. avant http) 
                // et ceux en fin de ligne (caractères permis suivis de . (qui peut être dans l'url) puis de \r ou \n
                var url_modele= /.([hH][tT][tT][pP][sS]?|[fF][tT][pP]):..[\x2F\x5B\x5D0-9a-zA-Z.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*.[^\r\n\x2F\x5B\x5D0-9a-zA-Z.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]/g ;
                //  la suivante ne prend que les url qui sont en début de ligne ou en fin de ligne ou seules sur une ligne
                var url_modeb = /(([\r\n]|^)([hH][tT]|[fF])[tT][pP][sS]?:..[\x5D\x5B\x2F0-9a-zA-Z.~:\x3F#_\x27@!&$\x28\x29\x2B\x2A,;=%-]*)|(.+([hH][tT]|[fF])[tT][pP][sS]?:..[\x5D\x5B\x2F0-9a-zA-Z.~:\x3F#_\x27@!&$\x28\x29\x2B\x2A,;=%-]*($|[\r\n]))/g ;
                var typurl = "HF" ;
                }
        if (document.getElementById('typedurl1').checked)       // si seulement les HTTP sont voulus
                {
                var url_modele= /.[hH][tT][tT][pP][sS]?:..[\x2F\x5B\x5D0-9a-zA-Z.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*.[^\r\n\x2F\x5B\x5D0-9a-zA-Z.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]/g ;
                var url_modeb = /(([\r\n]|^)[hH][tT][tT][pP][sS]?:..[\x5D\x5B\x2F0-9a-zA-Z.~:\x3F#_\x27@!&$\x28\x29\x2B\x2A,;=%-]*)|(.+[hH][tT][tT][pP][sS]?:..[\x5D\x5B\x2F0-9a-zA-Z.~:\x3F#_\x27@!&$\x28\x29\x2B\x2A,;=%-]*($|[\r\n]))/g ;
                var typurl = "H" ;
                }
        if (document.getElementById('typedurl2').checked)       // si seulement les FTP sont voulus
                {
                var url_modele= /.[fF][tT][pP]:..[\x2F\x5B\x5D0-9a-zA-Z.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*.[^\r\n\x2F\x5B\x5D0-9a-zA-Z.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]/g ;
                var url_modeb = /(([\r\n]|^)[fF][tT][pP]:..[\x5D\x5B\x2F0-9a-zA-Z.~:\x3F#_\x27@!&$\x28\x29\x2B\x2A,;=%-]*)|(.+[fF][tT][pP]:..[\x5D\x5B\x2F0-9a-zA-Z.~:\x3F#_\x27@!&$\x28\x29\x2B\x2A,;=%-]*($|[\r\n]))/g ;
                var typurl = "F" ;
                }
        // A ce stade, les liens voulus peuvent etre extraits a l'aide de url_modele et de url_modeb

        // ======================================================================================================
        // Extraction des url 
        // ======================================================================================================
        document.getElementById('compteur').innerHTML = "<p>HyperTeste extrait les liens du fichier... Veuillez patienter...</p>\n" ;
        var TabURL= fichier.match(url_modele) ;			// Extraction des liens dans le corps du texte et rangement dans ce tableau
        var TabURLdeb= fichier.match(url_modeb) ;		// Extraction des liens en debut ou  fin de ligne   ---   d°
        // Dans le tableau il y a les liens avec les caracteres qui precedent et qui suivent

        if 	(TabURL == null) 				// si TabURL est vide
                {
                var TabURLlength = 0 ;			// on note ce resultat en mettant cette variable a zero
                var TabURL = new Array() ;		// et on le ré-initialise
                }
        else
                {
                var TabURLlength = TabURL.length ;	// sinon on note son nombre d'elements
                }
			
        if 	(TabURLdeb == null)				// si TabURLdeb est vide
                {
                var TabURLdeblength = 0 ;		// on note ce resultat en mettant cette variable a zero
                var TabURLdeb = new Array() ;	// et on le ré-initialise
                }
        else
                {
                var TabURLdeblength = TabURLdeb.length ;	// sinon on note son nombre d'elements
                for (var jd = 0; jd < TabURLdeblength; jd++)
                        {
                        TabURL[TabURLlength+jd] = TabURLdeb[jd] ; // puis on copie ses éléments à la suite de ceux déjà présents dans TabURL
                        }
                TabURLlength = TabURL.length ;                          // et on met à jour la longueur du tableau
                }

        if ((TabURLlength == 0) && (TabURLdeblength == 0))		// si les deux tableaux etaient vides
                {                                                       // on l'affiche et on ne fait rien d'autre
                document.getElementById('compteur').innerHTML = "<br />" ;
                document.getElementById('affichage').innerHTML = "<h2>HyperTeste ne trouve pas de liens du type requis dans le fichier soumis</h2>" ; 
                }
        else                                                            // si des liens furent extraits
                {                                                       // on effectue le traitement


                // Nettoyage des liens et creation de la liste
                for (var j = 0; j < TabURLlength ; j++)
                        {                               // Boucle en j sur les liens

                        switch (typurl)
                                {
                                case "H":
alert("Case H, avant switch : " + TabURL[j]) ;
                                        switch (TabURL[j][0])
                                                {
                                                case "'":
                                                case '"':
//                                                      TabURL[j]= TabURL[j].replace(/.([hH][tT][tT][pP][sS]?:..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*).[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]/,"$1") ; // V6.04
                                                        //                                                                                                          ^ ce point est " ou '
                                                        TabURL[j]= TabURL[j].replace(/.([hH][tT][tT][pP][sS]?:..[\x2F\x5B\x5D\w.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*)[^\x2F\x5B\x5D\w.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*/,"$1") ;
alert("après switch, case guill. double : " + TabURL[j]) ;
                                                        break;
                                                default:
                                                        TabURL[j]= TabURL[j].replace(/.*([hH][tT][tT][pP][sS]?:..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*)[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*/,"$1") ;
alert("après switch, case default : " + TabURL[j]) ;
                                                }
                                        break ;
                                case "F":
                                        switch (TabURL[j][0])
                                                {
                                                case "'":
                                                case '"':
//                                                      TabURL[j]= TabURL[j].replace(/.([fF][tT][pP]:..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*).[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]/,"$1") ;
                                                        TabURL[j]= TabURL[j].replace(/.([fF][tT][pP]:..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*)[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*/,"$1") ;
                                                        break;
                                                default:
                                                        TabURL[j]= TabURL[j].replace(/.*([fF][tT][pP]:..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*)[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*/,"$1") ;
                                                        break;
                                                }
                                        break ;
                                case "HF":
                                        switch (TabURL[j][0])
                                                {
                                                case "'":
                                                case '"':
//                                                      TabURL[j]= TabURL[j].replace(/.(([hH][tT][tT][pP][sS]?|[fF][tT][pP]):..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*).[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]/,"$1") ;
                                                        TabURL[j]= TabURL[j].replace(/.(([hH][tT][tT][pP][sS]?|[fF][tT][pP]):..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*)[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*/,"$1") ;
                                                        break;
                                                default:
                                                        TabURL[j]= TabURL[j].replace(/.*(([hH][tT][tT][pP][sS]?|[fF][tT][pP]):..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*)[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*/,"$1") ;
                                                        break;
                                                }
                                        break ;
                                default:
                                        switch (TabURL[j][0])
                                                {
                                                case "'":
                                                case '"':
//                                                      TabURL[j]= TabURL[j].replace(/.(([hH][tT][tT][pP][sS]?|[fF][tT][pP]):..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*).[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]/,"$1") ;
                                                        TabURL[j]= TabURL[j].replace(/.(([hH][tT][tT][pP][sS]?|[fF][tT][pP]):..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*)[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*/,"$1") ;
                                                        break;
                                                default:
                                                        TabURL[j]= TabURL[j].replace(/.*(([hH][tT][tT][pP][sS]?|[fF][tT][pP]):..[\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*)[^\x2F\x5B\x5D\w\d.~:\x3F#_@!&$\x27\x28\x29*+,;=%-]*/,"$1") ;
                                                        break;
                                                }
                                        break ;
                                }
                        }

                // Fin de la boucle en j sur les liens. Les liens nettoyés sont dans TabURL[j]
                }
        document.getElementById('affichage').innerHTML = "<p></p>" ;
        document.getElementById('compteur').innerHTML = "<p>Extraction terminée.</p>" ;
        }
    catch (e)
        {
alert(e.message) ;
        document.getElementById('compteur').innerHTML = "<p></p>" ;
        document.getElementById('affichage').innerHTML = "<h2>HyperTeste ne peut pas ouvrir le fichier soumis,<br />" 
                + "vérifier ses nom et emplacement<br /> ou bien les règles de sécurité du navigateur !</h2>" ; 
        }
        // Sauf erreur, les liens sont dans le tableau et il reste a les tester en php

    // =====================================================================================================================================
    // =========================================== CHARGEMENT DES LIENS DANS LE FORMULAIRE DE TEST =========================================
    // =====================================================================================================================================
    document.getElementById('divphp').innerHTML = "" ;
    var idCourant = "" ;
    // Initialisation du formulaire en vue du traitement php
    document.getElementById('formtest').innerHTML = 
                    '\n<p id="nbliens">Nombre de liens extraits de ' + url + ' : <input size="10" id="nblienstest" name="nblienstest" />.'
                        + '<input type="hidden" id="urlfichier" name="urlfichier" /></p>\n' ;   // 6.03 pour transmettre le nom de fichier au php
    // Creation des champs pour les URL
    for (var j = 0; j < TabURLlength ; j++)
        {                               // Boucle en j sur les liens
        // Construction d'un identifiant unique pour le champ j du formulaire
        idCourant = "idURL" + j.toString() ;
        // Insertion du champ j dans le formulaire
        document.getElementById('formtest').innerHTML += '<input size="120" id="' + idCourant + '"  name="' + idCourant + '" /><br />\n' ;
        }

    // Insertion du bouton de soumission du formulaire
    document.getElementById('formtest').innerHTML += 
      '<p class="inepoute"><strong>Appuyer sur le bouton pour… : </strong><input id="testerliens" type="submit" value="Tester les liens" /></p>' ;
    document.getElementById('formtest').innerHTML += '<p>(le temps d’attente n’excèdera pas ' + (3*TabURLlength).toString() + ' secondes)</p>\n' ;

    // Ecriture des valeurs dans les champs
    document.getElementById('nblienstest').value = TabURLlength ;
    document.getElementById('urlfichier').value = url ;                         // 6.03

    for (var j = 0; j < TabURLlength ; j++)
        {                               // Boucle en j sur les liens
        // Construction d'un identifiant unique pour le champ j du formulaire
        idCourant = "idURL" + j.toString() ;
        // Ecriture de sa valeur dans le champ j
        document.getElementById(idCourant).value = TabURL[j] ;
        }
    }   // Fin de la fonction ChargeFichier(url)

//===================================================================
// Cette fonction permet le lancement du traitement par appui sur la 
// touche entree en fin de saisie du nom de fichier soumis

function Envoi(e)
	{
	var touche ;
	if (window.event) touche = window.event.keyCode ;
	else 	if (e) touche = e.which;
		else return true;

	if (touche == 13)
   		{
		ChargeFichier(document.getElementById('EntreNomFichier').elements[0].value) ;
   		return false;
   		}
	else
   	return true;
	}


